function Lmtppm(lmt::Int,a6::Array,al::Array,ar::Array,dc::Array,qa::Array)
    # ---START LMTPPM---
    #a61 = copy(a6)
    #al1 = copy(al)
    #ar1 = copy(ar)
    a61 = zeros(size(a6))
    al1 = zeros(size(al))
    ar1 = zeros(size(ar))
    vecLen = length(a6)
    iStart = 2
    iEnd = vecLen - 1
    ratio12 = 1.0/12.0
    if lmt == 0
        for iEl = iStart:iEnd
            if dc[iEl] == 0.0
                a61[iEl] = 0.0
                al1[iEl] = qa[iEl]
                ar1[iEl] = qa[iEl]
            else
                da1 = ar[iEl] - al[iEl]
                da2 = da1*da1
                a6da = a6[iEl] * da1
                if a6da < (-da2)
                    a61[iEl] = 3.0*(ar[iEl] - qa[iEl])
                    ar1[iEl] = al[iEl] - a61[iEl]
                elseif a6da > da2
                    a61[iEl] = 3.0*(ar[iEl] - qa[iEl])
                    al1[iEl] = ar[iEl] - a61[iEl]
                end
            end
        end
    elseif lmt == 1
        for iEl = iStart:iEnd
            if (abs(ar[iEl]-al[iEl]) < -a6[iEl])
                if ((qa[iEl]<ar[iEl])&&(qa[iEl]<al[iEl]))
                    a61[iEl] = 0.0
                    al1[iEl] = qa[iEl]
                    ar1[iEl] = qa[iEl]
                elseif ar[iEl] > al[iEl]
                    a61[iEl] = 3.0*(al[iEl] - qa[iEl])
                    ar1[iEl] = al[iEl] - a61[iEl]
                else
                    a61[iEl] = 3.0*(ar[iEl] - qa[iEl])
                    al1[iEl] = ar[iEl] - a61[iEl]
                end
            end
        end
    elseif lmt == 2
        for iEl = iStart:iEnd
            fTemp = ar[iEl] - al[iEl]
            if (abs(fTemp) < -a6[iEl])
                fMin = qa[iEl] + (0.25 * (fTemp*fTemp) / a6[iEl] + a6[iEl] * (1.0/2.0))
                if fMin < 0.0
                    if ((qa[iEl]<ar[iEl])&&(qa[iEl]<al[iEl]))
                        a61[iEl] = 0.0
                        al1[iEl] = qa[iEl]
                        ar1[iEl] = qa[iEl]
                    elseif ar[iEl] > al[iEl]
                        a61[iEl] = 3.0*(al[iEl] - qa[iEl])
                        ar1[iEl] = al[iEl] - a61[iEl]
                    else
                        a61[iEl] = 3.0*(ar[iEl] - qa[iEl])
                        al1[iEl] = ar[iEl] - a61[iEl]
                    end
                end
            end
        end
    end
    return(a61,al1,ar1)
end

